'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _imask = require('imask');

var _imask2 = _interopRequireDefault(_imask);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MaskInput = function (_Component) {
  (0, _inherits3.default)(MaskInput, _Component);

  function MaskInput() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MaskInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MaskInput.__proto__ || (0, _getPrototypeOf2.default)(MaskInput)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (ev, _ref2) {
      var value = _ref2.value;
      var onChange = _this.props.onChange;

      onChange && onChange(ev, { value: value });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MaskInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var mask = this.props.mask;

      this.mask = new _imask2.default(this.field, mask);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.mask.destroy();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var name = this.props.name;

      return _react2.default.createElement(_Input2.default, (0, _extends3.default)({
        id: name,
        reference: function reference(input) {
          _this2.field = input;
        },
        onChange: this.onChange
      }, this.props));
    }
  }]);
  return MaskInput;
}(_react.Component);

MaskInput.displayName = 'MaskInput';

MaskInput.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /* mask object, see https://unmanner.github.io/imaskjs/ */
  mask: _propTypes2.default.object.isRequired,
  /* The name of the control */
  name: _propTypes2.default.string,
  /* Event launched on every input change */
  onChange: _propTypes2.default.func
} : {} : {};

exports.default = MaskInput;